unit setMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, IniFiles, FileCtrl,
  ZLib, BrowseFolder, Brkapart, GoToWeb, checklst;

type
  Tfrm_Setup_Main = class(TForm)
    Notebook: TNotebook;
    Image_Page1: TImage;
    Label1: TLabel;
    lbTitle: TLabel;
    Label3: TLabel;
    Bevel1: TBevel;
    btnNext: TButton;
    btnPrev: TButton;
    btnCancel: TButton;
    Label_Page2: TLabel;
    Image_Page2: TImage;
    Label4: TLabel;
    edDest: TEdit;
    btnDirSearch: TButton;
    BrowseFolder: TBrowseFolder;
    Label2: TLabel;
    Gruppen: TCheckListBox;
    cbGroup: TComboBox;
    Label5: TLabel;
    BrkApart: TBrkApart;
    Label6: TLabel;
    Image1: TImage;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    GoToWeb: TGoToWeb;
    Label10: TLabel;
    Label11: TLabel;
    BrkLinks: TBrkApart;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnPrevClick(Sender: TObject);
    procedure btnDirSearchClick(Sender: TObject);
    procedure Label10Click(Sender: TObject);
  private
    Inf : TIniFile;
    Log : TStringList;
    Succesful : Boolean;
    procedure SetupError(const ErrorCode : Integer;const Msg : String;Stop : Boolean);
    procedure SetupInit;
    procedure SetupFree;
    procedure Status(Sender: TObject);
  public
  end;

var
  frm_Setup_Main: Tfrm_Setup_Main;

implementation

uses
    setVar, setTool, setCopy, setChng, setRead;

{$R *.DFM}

    procedure Tfrm_Setup_Main.SetupError(const ErrorCode : Integer;const Msg : String;Stop : Boolean);
    begin
         ShowMessage(
          format(
           'Setup Fehler:'#13 +
           'Fehler Nummer %d: %s.',
           [ErrorCode, Msg]
          )
         );
         if Stop then Halt(ErrorCode);
    end;

    procedure Tfrm_Setup_Main.SetupInit;
    var
       Idx  : Integer;
       iTmp : Integer;
       sTmp : String;
    begin
         // ffnen
         if not FileExists(RootDir + 'setup.inf') then
            SetupError(1, 'Setup Skript nicht gefunden', True);
         Inf := TIniFile.Create(RootDir + 'setup.inf');
         // gruppen
         iTmp := Inf.ReadInteger('Groups', 'Count', 0);
         for Idx := 0 to iTmp - 1 do
         begin
              sTmp := Inf.ReadString('Groups', IntToStr(Idx + 1), '?');
              Groups.Add(sTmp);
              Gruppen.Items.Add(sTmp);
         end;
         for Idx := 0 to iTmp - 1 do
             Gruppen.Checked[Idx] := True;
         // zielpfad
         sTmp := Inf.ReadString('Common', 'DefaultPath', 'Default');
         edDest.Text := InstallDir + sTmp;
         DefaultDir := sTmp;
         DestDir := edDest.Text;
         // verzeichnisse
         iTmp := Inf.ReadInteger('Dirs', 'Count', 0);
         for Idx := 0 to iTmp - 1 do
         begin
              sTmp := Inf.ReadString('Dirs', IntToStr(Idx + 1), '');
              Dirs.Add(sTmp);
         end;
         // default gruppe
         DefaultGroup := Inf.ReadString('Common', 'DefaultGroup', '');
         cbGroup.Text := DefaultGroup;
         cbGroup.Items.Add(DefaultGroup);
    end;

    procedure Tfrm_Setup_Main.SetupFree;
    begin
         Inf.Free;
    end;

procedure Tfrm_Setup_Main.FormCreate(Sender: TObject);
begin
     // falls keine Parameter, dann raus
     if ZipSrc = '' then
        SetupError(-1, 'Parameter: setup [Standort der Archive]', True);
     // erste Seite
     NoteBook.PageIndex := 0;
     // inf Datei ffnen und Initialierung
     SetupInit;
     // standard werte lesen und setzen
     Title := Inf.ReadString('Common', 'Title', '?');
     lbTitle.Caption := format(lbTitle.Caption, [Title]);
     ReadmeFile := Inf.ReadString('Common', 'ReadmeFile', '');
     ProgramAfter := Inf.ReadString('Common', 'RunProgramAfter', '');
     // Log erzeugen
     Log := TStringList.Create;
     Log.Add('Setup Toolkit v1.00 by Sven Bobrowski.');
end;

procedure Tfrm_Setup_Main.FormDestroy(Sender: TObject);
var
   sTmp : String;
begin
     SetupFree;
     if Succesful then
     begin
          sTmp := edDest.Text;
          if Copy(sTmp, Length(sTmp), 1) <> '\' then sTmp := sTmp + '\';
          try
             Log.SaveToFile(sTmp + 'deinst.log');
          except
                ShowMessage('Logdatei konnte nicht gespeichert werden!');
          end;
     end;
end;

procedure Tfrm_Setup_Main.btnCancelClick(Sender: TObject);
begin
     Close;
end;

procedure Tfrm_Setup_Main.Status(Sender: TObject);
begin
     frm_Copy.ProgressBar1.Position := TCustomZLibStream(Sender).Position;
end;

procedure Tfrm_Setup_Main.btnNextClick(Sender: TObject);
var
   DestDir : String;
   TmpDir : String;
   DeCmpDir : String;
   DiskCnt : Integer;
   DiskIdx : Integer;
   DiskId : String;
   wTemp : Word;
   DirIdx : Integer;
   sTmp : String;
   ArcCnt : Integer;
   ArcIdx : Integer;
   ArcName : String;
   ArcDir : Integer;
   ArcTitle : String;
   ArcGroup : Integer;
   ArcSplit : String;
   DcmpParam : TDecompParameter;
   cpSource : String;
   cpDest : String;
   streamSource : TStream;
   streamDest : TStream;
   Bloecke : Integer;
   Rest    : Integer;
   Idx : Integer;
   Count : Integer;
   Prozent : Integer;
   Buffer : Array[0..BufferSize - 1] of Byte;
   lnkCount : Integer;
   lnkIdx : Integer;
   strExeFuelPath : String;
   strIcon : String;

   procedure Cleanup;
   var
      Idx : Integer;
   begin
        for Idx := Dirs.Count downto 1 do
        begin
             sTmp := DestDir + Dirs[Idx - 1];
             try
                // CleanupDir(sTmp);
                RmDir(sTmp);
             except
             end;
             if Copy(sTmp, Length(sTmp), 1) = '\' then
                sTmp := Copy(DestDir, 1, Length(sTmp) - 1)
             else
                 sTmp := DestDir;
             try
                // CleanupDir(sTmp);
                RmDir(sTmp);
             except
             end;
        end;
   end;

begin
     case NoteBook.PageIndex of
       0:
         begin
              // tempdir
              TmpDir := ExtractFileDir(Application.ExeName);
              if Copy(TmpDir, Length(TmpDir), 1) <> '\' then
                 TmpDir := TmpDir + '\';
              // Readme falls angegeben
              if ReadmeFile <> '' then
              begin
                   frm_Readme := Tfrm_Readme.Create(Application);
                   frm_Readme.RichEdit.Lines.LoadFromFile(TmpDir + ReadmeFile);
                   frm_Readme.ShowModal;
                   frm_Readme.Release;
              end;
              // -> Optionen
              NoteBook.PageIndex := 1;
              btnPrev.Enabled := True;
         end;
       1:
         begin
              // noch nicht beendet
              Succesful := False;

              // Optionen checken
              if edDest.Text = '' then
              begin
                   ShowMessage('Fehler: Sie mssen einen Zielordner festlegen!');
                   edDest.SetFocus;
                   Exit;
              end;

              // zielverzeichnis
              DestDir := edDest.Text;
              try
                 MkDir(DestDir);
                 Log.Insert(Log.Count, 'DIRECTORY,' + DestDir);
              except
                begin
                     ShowMessage('Fehler: Der Zielordner konnte nicht angelegt werden!');
                     Exit;
                end;
              end;
              if Copy(DestDir, Length(DestDir), 1) <> '\' then
                 DestDir := DestDir + '\';
              // tempdir
              TmpDir := GetEnvStr('TEMP');
              if TmpDir = '' then TmpDir := ExtractFileDir(Application.ExeName);
              if Copy(TmpDir, Length(TmpDir), 1) <> '\' then
                 TmpDir := TmpDir + '\';
              // temporary decomp dir
              DeCmpDir := TmpDir;
              if Copy(DeCmpDir, Length(DeCmpDir), 1) <> '\' then
                 DeCmpDir := DeCmpDir + '\';

              // verzeichnisstruktur anlegen
              for DirIdx := 1 to Dirs.Count do
              begin
                   sTmp := DestDir + Dirs[DirIdx - 1];
                   try
                      MkDir(sTmp);
                      Log.Insert(Log.Count, 'DIRECTORY,' + sTmp);
                   except
                     begin
                          ShowMessage('Konnte Verzeichnis "' + sTmp + '" nicht erstellen!');
                          Cleanup;
                          Halt(11);
                     end;
                   end;
              end;

              frm_Copy.Show;
              Application.ProcessMessages;

              // kopieren
              DiskCnt := Inf.ReadInteger('Disksets', 'Count', 0);
              for DiskIdx := 1 to DiskCnt do
              begin
                   // disk label
                   frm_Copy.lbDisk.Caption := Format('Diskette %d/%d', [DiskIdx, DiskCnt]);
                   Application.ProcessMessages;
                   // disk id checken und falls notwendig Diskette anfordern
                   DiskId := Inf.ReadString('Disk' + IntToStr(DiskIdx), 'Id', '');
                   if DiskId <> '' then
                   begin
                        wTemp := 0;
                        if NOT FileExists(ZipSrc + DiskId) then
                        repeat
                              wTemp := CopyDlg(DiskIdx, ZipSrc);
                        until
                          ((wTemp = mrOk) AND (FileExists(ZipSrc + DiskId))) OR
                          (wTemp = mrCancel);
                        if wTemp = mrCancel then
                        begin
                             Cleanup;
                             Halt(10);
                        end;
                   end;
                   // archive nacheinander bearbeitne
                   ArcCnt := Inf.ReadInteger('Disk' + IntToStr(DiskIdx), 'Count', 0);
                   for ArcIdx := 1 to ArcCnt do
                   begin
                        // Infos holen
                        sTmp := Inf.ReadString('Disk' + IntToStr(DiskIdx), IntToStr(ArcIdx), '');
                        ArcGroup := -1;
                        ArcDir := -1;
                        if sTmp <> '' then
                        begin
                             BrkApart.BaseString := sTmp;
                             BrkApart.BreakApart;
                             try
                                ArcName := BrkApart.StringList[0];
                                ArcDir := StrToInt(BrkApart.StringList[1]);
                                ArcTitle := BrkApart.StringList[2];
                                ArcGroup := StrToInt(BrkApart.StringList[3]);
                                ArcSplit := BrkApart.StringList[4];
                             except
                               begin
                                   ShowMessage('Fehler in Skriptdatei, Section Diskette ' + IntToStr(DiskIdx));
                                   Cleanup;
                                   Halt(13);
                               end;
                             end;
                        end;
                        // gruppe berhaupt installieren
                        if Gruppen.Checked[ArcGroup - 1] then
                        begin
                             if ArcSplit = '#' then
                             begin
                                  // gleich entpacken
                                  with DcmpParam do
                                  begin
                                       strTmpDir := DeCmpDir;
                                       strArchivName := ArcName;
                                       strSourcePath := ZipSrc;
                                       if Dirs[ArcDir - 1] = '' then
                                          strDestPath := DestDir
                                       else
                                           strDestPath := DestDir + Dirs[ArcDir - 1] + '\';
                                       objMsgFile := frm_Copy.lbFile;
                                       objProgress := frm_Copy.ProgressBar1;
                                       objStatus := Status;
                                       objLog := Log;
                                  end;
                                  frm_Copy.lbMain.Caption := ArcTitle;
                                  if CopyAndDecompressZArchiv(DcmpParam) <> 0 then
                                     ShowMessage('Fehler beim Entpacken des Archivs ' + ArcName);
                             end else
                             begin
                                  // erst mal kopieren
                                  if Pos('#', ArcSplit) = 0 then
                                  begin
                                       (* Archiv wurde gesplittet.
                                          Falls Splitnummer = 1 dann temporre Datei erstellen
                                          und ersten Teil kopieren *)
                                       if StrToInt(ArcSplit) = 1 then
                                       begin
                                            // initialisieren
                                            cpSource := ZipSrc + ArcName;
                                            cpDest := DeCmpDir + 'split.z';
                                            streamSource := TFileStream.Create(cpSource, fmOpenRead);
                                            streamDest := TFileStream.Create(cpDest, fmCreate);
                                            frm_Copy.lbMain.Caption := format('Bearbeite %s', [ArcTitle]);
                                            frm_Copy.lbFile.Caption := format('Kopiere %s', [ArcName]);
                                            Application.ProcessMessages;
                                            // datei kopieren -> Temp
                                            Bloecke := Trunc(streamSource.Size / BufferSize);
                                            Rest    := streamSource.Size - (Bloecke * BufferSize);
                                            frm_Copy.ProgressBar1.Max := 100;
                                            Idx := 1;
                                            repeat
                                                  if (Idx <= Bloecke) then
                                                  begin
                                                       Count := streamSource.Read(Buffer, BufferSize);
                                                       streamDest.Write(Buffer, Count);
                                                  end else
                                                  begin
                                                       Count := streamSource.Read(Buffer, Rest);
                                                       streamDest.Write(Buffer, Count);
                                                  end;
                                                  inc(Idx, 1);
                                                  Prozent := Round(( (streamSource.Position / streamSource.Size) * 100));
                                                  frm_Copy.ProgressBar1.Position := Prozent;
                                                  Application.ProcessMessages;
                                            until Idx > (Bloecke + 1);
                                            // freigeben
                                            streamSource.Free;
                                            streamDest.Free;
                                       end else
                                       (* Archiv wurde gesplittet.
                                          Jetzt mssen wir nacheinander alle Teile kopieren.
                                       *)
                                       if (StrToInt(ArcSplit) > 1) AND (Pos('#', ArcSplit) = 0) then
                                       begin
                                            // initialisieren
                                            cpSource := ZipSrc + ArcName;
                                            cpDest := DeCmpDir + 'split.z';
                                            streamSource := TFileStream.Create(cpSource, fmOpenRead);
                                            streamDest := TFileStream.Create(cpDest, fmOpenwrite);
                                            streamDest.Seek(0, soFromEnd);
                                            frm_Copy.lbMain.Caption := format('Bearbeite %s', [ArcTitle]);
                                            frm_Copy.lbFile.Caption := format('Kopiere %s', [ArcName]);
                                            Application.ProcessMessages;
                                            // datei kopieren -> Temp
                                            Bloecke := Trunc(streamSource.Size / BufferSize);
                                            Rest    := streamSource.Size - (Bloecke * BufferSize);
                                            frm_Copy.ProgressBar1.Max := 100;
                                            Idx := 1;
                                            repeat
                                                  if (Idx <= Bloecke) then
                                                  begin
                                                       Count := streamSource.Read(Buffer, BufferSize);
                                                       streamDest.Write(Buffer, Count);
                                                  end else
                                                  begin
                                                       Count := streamSource.Read(Buffer, Rest);
                                                       streamDest.Write(Buffer, Count);
                                                  end;
                                                  inc(Idx, 1);
                                                  Prozent := Round(( (streamSource.Position / streamSource.Size) * 100));
                                                  frm_Copy.ProgressBar1.Position := Prozent;
                                                  Application.ProcessMessages;
                                            until Idx > (Bloecke + 1);
                                            // freigeben
                                            streamSource.Free;
                                            streamDest.Free;
                                       end;
                                  end else
                                  (* Alle Teile wurden kopiert in -> Temp und zusammengestzt.
                                     Jetzt wird noch der Rest kopiert und das Archiv dann
                                     entpackt und danach gelscht!
                                  *)
                                  begin
                                       // initialisieren
                                       cpSource := ZipSrc + ArcName;
                                       cpDest := DeCmpDir + 'split.z';
                                       streamSource := TFileStream.Create(cpSource, fmOpenRead);
                                       streamDest := TFileStream.Create(cpDest, fmOpenwrite);
                                       streamDest.Seek(0, soFromEnd);
                                       frm_Copy.lbMain.Caption := format('Bearbeite %s', [ArcTitle]);
                                       frm_Copy.lbFile.Caption := format('Kopiere %s', [ArcName]);
                                       Application.ProcessMessages;
                                       // datei kopieren -> Temp
                                       Bloecke := Trunc(streamSource.Size / BufferSize);
                                       Rest    := streamSource.Size - (Bloecke * BufferSize);
                                       frm_Copy.ProgressBar1.Max := 100;
                                       Idx := 1;
                                       repeat
                                             if (Idx <= Bloecke) then
                                             begin
                                                  Count := streamSource.Read(Buffer, BufferSize);
                                                  streamDest.Write(Buffer, Count);
                                             end else
                                             begin
                                                  Count := streamSource.Read(Buffer, Rest);
                                                  streamDest.Write(Buffer, Count);
                                             end;
                                             inc(Idx, 1);
                                             Prozent := Round(( (streamSource.Position / streamSource.Size) * 100));
                                             frm_Copy.ProgressBar1.Position := Prozent;
                                             Application.ProcessMessages;
                                       until Idx > (Bloecke + 1);
                                       // freigeben
                                       streamSource.Free;
                                       streamDest.Free;
                                       // jetzt knnen wir das Archiv entpacken
                                       with DcmpParam do
                                       begin
                                            strTmpDir := DeCmpDir;
                                            strArchivName := ExtractFileName(cpDest);
                                            strSourcePath := DeCmpDir;
                                            if Dirs[ArcDir - 1] = '' then
                                               strDestPath := DestDir
                                            else
                                                strDestPath := DestDir + Dirs[ArcDir - 1] + '\';
                                            objMsgFile := frm_Copy.lbFile;
                                            objProgress := frm_Copy.ProgressBar1;
                                            objStatus := Status;
                                            objLog := Log;
                                       end;
                                       frm_Copy.lbMain.Caption := ArcTitle;
                                       if CopyAndDecompressZArchiv(DcmpParam) <> 0 then
                                          ShowMessage('Fehler beim Entpacken des Archivs ' + ArcName);
                                       // archiv lschen
                                       DeleteFile(cpDest);
                                  end;
                             end;
                        end;
                   end;
              end;

              // Links anlegen
              lnkCount := Inf.ReadInteger('Links', 'Count', 0);
              for lnkIdx := 1 to lnkCount do
              begin
                   sTmp := Inf.ReadString('Links', IntToStr(lnkIdx), '');
                   Links.Add(sTmp);
              end;
              for lnkIdx := 1 to Links.Count do
              begin
                   sTmp := Links[lnkIdx - 1];
                   try
                      BrkLinks.BaseString := sTmp;
                      BrkLinks.BreakApart;
                      strExeFuelPath := edDest.Text;
                      if Copy(strExeFuelPath, Length(strExeFuelPath), 1) <> '\' then
                         strExeFuelPath := strExeFuelPath + '\';
                      strExeFuelPath := strExeFuelPath + BrkLinks.StringList[0];
                      strIcon := BrkLinks.StringList[1];
                      CreateProgramLink(strExeFuelPath, strIcon);
                      Log.Insert(Log.Count, 'LINK,' + strExeFuelPath + ',' + strIcon);
                   except
                   end;
              end;

              Succesful := True;

              // -> Ende
              frm_Copy.Hide;
              NoteBook.PageIndex := 2;
              btnPrev.Enabled := False;
              btnNext.Caption := '&Ende';
         end;
       2:
         begin
              // falls ein Programm gesetzt nach Ende dann jetzt starten
              if ProgramAfter <> '' then
              begin
                   sTmp := edDest.Text;
                   if Copy(sTmp, Length(sTmp), 1) <> '\' then
                      sTmp := sTmp + '\';
                   sTmp := sTmp + ProgramAfter;
                   WinExec(PChar(sTmp), SW_SHOWNORMAL);
              end;
              // Beenden
              Close;
         end;
     end;
end;

procedure Tfrm_Setup_Main.btnPrevClick(Sender: TObject);
begin
     case NoteBook.PageIndex of
       1:
         begin
              // -> Start
              NoteBook.PageIndex := 0;
              btnPrev.Enabled := False;
         end;
     end;
end;

procedure Tfrm_Setup_Main.btnDirSearchClick(Sender: TObject);
begin
     BrowseFolder.Directory := InstallDir;
     if BrowseFolder.Execute then
     begin
          DestDir := BrowseFolder.Directory;
          if copy(DestDir, Length(DestDir), 1) <> '\' then
             DestDir := DestDir + '\';
          DestDir := DestDir + DefaultDir;
          edDest.Text := DestDir;
     end;
end;

procedure Tfrm_Setup_Main.Label10Click(Sender: TObject);
begin
     GoToWeb.Execute;
end;

end.
