unit setVar;

interface

uses
    Windows, Forms, Classes, SysUtils,
    setType;

var
   // Setup
   RootDir : String;
   ZipSrc : String;
   Title : String;
   DefaultGroup : String;
   Groups : TStringList;
   Dirs : TStringList;
   Links : TStringList;
   InstallDir : String;
   DefaultDir : String;
   DestDir : String;
   ReadmeFile : String;
   ProgramAfter : String;
   // Windows
   WinDir : String;
   WinSysDir : String;

implementation

var
   Buffer : PChar;
   tReg : TRegistration;

initialization
  // Setup
  RootDir := ExtractFileDir(Application.ExeName);
  if Copy(RootDir, Length(RootDir), 1) <> '\' then
     RootDir := RootDir + '\';
  ZipSrc := ParamStr(1);
  if Copy(ZipSrc, Length(ZipSrc), 1) <> '\' then
     ZipSrc := ZipSrc + '\';
  Groups := TStringList.Create;
  Dirs := TStringList.Create;
  Links := TStringList.Create;
  // Windows
  GetMem(Buffer, 255);
  GetWindowsDirectory(Buffer, 255);
  WinDir := StrPas(Buffer);
  GetSystemDirectory(Buffer, 255);
  WinSysDir := StrPas(Buffer);
  FreeMem(Buffer, 255);
  // Registry
  tReg := TRegistration.Create;
  tReg.SetKey(HKEY_LOCAL_MACHINE, 'SOFTWARE\Microsoft\Windows\CurrentVersion');
  InstallDir := tReg.GetStrValue('', 'ProgramFilesDir');
  if copy(InstallDir, Length(InstallDir), 1) <> '\' then
     InstallDir := InstallDir + '\';
  tReg.Free;
finalization
  // Setup
  Groups.Free;
  Dirs.Free;
  Links.Free;
end.
